/*
	rk4_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	12-Sep-99	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "rk4n.hh" 	// rk4Format

// NML Channel Pointers
static RCS_CMD_CHANNEL *rk4_cmd = NULL;
static RCS_STAT_CHANNEL *rk4_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// rk4
	rk4_cmd = new RCS_CMD_CHANNEL(rk4Format, "rk4_cmd", "rk4_modulesvr", "rk4_module.nml");
	if(NULL == rk4_cmd)
		return -1;
	if(!rk4_cmd->valid())
		return -1;

	rk4_stat = new RCS_STAT_CHANNEL(rk4Format, "rk4_sts", "rk4_modulesvr", "rk4_module.nml");
	if(NULL == rk4_stat)
		return -1;
	if(!rk4_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "rk4_modulesvr", "rk4_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// rk4
	if(NULL != rk4_cmd)
	{
		delete rk4_cmd;
		rk4_cmd = NULL;
	}

	if(NULL != rk4_stat)
	{
		delete rk4_stat;
		rk4_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int rk4_modulesvr_run();

int rk4_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

