/*
rk4.hh

This C++ header file defines the class RK4_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
12-Sep-99	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef RK4_HH
#define RK4_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rk4_sim.hh" 	// RK4SIM definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "rk4n.hh" 	// NML Commands and Status definitions for rk4
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class RK4_MODULE: public NML_MODULE, public RK4_SIM
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

       // Constructor  
       RK4_MODULE(int _is_base_class = 0); 
  
	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(RK4_INIT *);
	virtual void HALT(RK4_HALT *);
	virtual void RUN(RK4_RUN *);

  // DERIV contains the dynamic equations of the system in the 
  // form: xdot = f(t,x,u); arguments are the time t, present state 
  // values x, the present control value u, and values of the derivatives 
  // of the states xdot (calculated inside of the funtcion). 
  // It is defined in RK4_SIM class and overloaded here
  void DERIV(const double t, const double *x, 
             const double *u, double *xdot);

  void FIND_CTRL_INPUT(void);
  
	// Convenience Variables
	RK4_STATUS *rk4_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int num_sim_per_cycle; // # of simulations to be performed per sampling time
  double cycle_time; // The cycle time for the module

};

#endif 	// RK4_HH

